diff mbox series

[v2] fstests: add generic/609 to test O_DIRECT|O_DSYNC

Message ID 32b2e9a1d92e875a60ff6ff83ba5e1e386118df5.1599060956.git.josef@toxicpanda.com (mailing list archive)
State New, archived
Headers show
Series [v2] fstests: add generic/609 to test O_DIRECT|O_DSYNC | expand

Commit Message

Josef Bacik Sept. 2, 2020, 3:37 p.m. UTC
We had a problem recently where btrfs would deadlock with
O_DIRECT|O_DSYNC because of an unexpected dependency on ->fsync in
iomap.  This was only caught by chance with aiostress, because weirdly
we don't actually test this particular configuration anywhere in
xfstests.  Fix this by adding a basic test that just does
O_DIRECT|O_DSYNC writes.  With this test the box deadlocks right away
with Btrfs, which would have been helpful in finding this issue before
the patches were merged.

Reviewed-by: Johannes Thumshirn <johannes.thumshirn@wdc.com>
Signed-off-by: Josef Bacik <josef@toxicpanda.com>
---
v1->v2:
- Fix the spelling thing Johannes spotted.
- Use xfs_io like a normal person.

 tests/generic/609   | 44 ++++++++++++++++++++++++++++++++++++++++++++
 tests/generic/group |  1 +
 2 files changed, 45 insertions(+)
 create mode 100755 tests/generic/609
diff mbox series

Patch

diff --git a/tests/generic/609 b/tests/generic/609
new file mode 100755
index 00000000..6f3ab055
--- /dev/null
+++ b/tests/generic/609
@@ -0,0 +1,44 @@ 
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2020 Josef Bacik.  All Rights Reserved.
+#
+# FS QA Test 609
+#
+# iomap can call generic_write_sync() if we're O_DSYNC, so write a basic test to
+# exercise O_DSYNC so any unsuspecting file systems will get lockdep warnings if
+# their locking isn't compatible.
+#
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	rm -f $tmp.*
+	rm -rf $TEST_DIR/file
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# Modify as appropriate.
+_supported_fs generic
+_supported_os Linux
+_require_test
+_require_xfs_io_command "pwrite" "-DV"
+
+$XFS_IO_PROG -f -d -c "pwrite -D -V 1 0 4k"  $TEST_DIR/file
+
+echo "Silence is golden"
+status=0
+exit
diff --git a/tests/generic/group b/tests/generic/group
index aa969bcb..ae2567a0 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -611,3 +611,4 @@ 
 606 auto attr quick dax
 607 auto attr quick dax
 608 auto attr quick dax
+609 auto quick